"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.AutomationTestLog = void 0;
var QTestResource_1 = require("./QTestResource");
var AutomationTestLog = /** @class */ (function (_super) {
    __extends(AutomationTestLog, _super);
    function AutomationTestLog() {
        return _super.call(this) || this;
    }
    Object.defineProperty(AutomationTestLog.prototype, "testRunId", {
        get: function () {
            return this._testRunId;
        },
        set: function (id) {
            this._testRunId = id;
            this._refreshURL();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AutomationTestLog.prototype, "projectId", {
        get: function () {
            return this._projectId;
        },
        set: function (id) {
            this._projectId = id;
            this._refreshURL();
        },
        enumerable: false,
        configurable: true
    });
    AutomationTestLog.prototype.toJSON = function () {
        var json = {
            links: this.links,
            id: this.id,
            exe_start_date: this.executionStartDate,
            exe_end_date: this.executionEndDate,
            attachments: this.attachments,
            status: this.status,
            name: this.name,
            automation_content: this.automationContent,
            note: this.note,
            test_step_logs: this.testStepLogs
        };
        return json;
    };
    AutomationTestLog.prototype.fromJSON = function (json) {
        this.links = json.links;
        this.id = json.id;
        this.testCaseVersionId = json.test_case_version_id;
        this.executionStartDate = json.exe_start_date;
        this.executionEndDate = json.exe_end_date;
        this.attachments = json.attachments;
        this.status = json.status.name;
        this.testStepLogs = json.test_step_logs;
        this.note = json.note || "";
        return this;
    };
    AutomationTestLog.prototype._refreshURL = function () {
        this.createURL = "/api/v3/projects/" + this.projectId + "/test-runs/" + this.testRunId + "/auto-test-logs";
    };
    return AutomationTestLog;
}(QTestResource_1.QTestResource));
exports.AutomationTestLog = AutomationTestLog;
