"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.Finder = void 0;
var Requester_1 = require("./Requester");
var TestCase_1 = require("../models/TestCase");
var AutomationTestLog_1 = require("../models/AutomationTestLog");
var Query_1 = require("../models/Query");
var QueryResult_1 = require("../models/QueryResult");
var TestRun_1 = require("../models/TestRun");
var Finder = /** @class */ (function (_super) {
    __extends(Finder, _super);
    function Finder(host, token) {
        var _this = _super.call(this, host) || this;
        _this.token = token;
        _this.header = { "name": "Authorization", "value": token };
        _this.header = { "name": "Accept", "value": "application/json" };
        _this.header = { "name": "Content-Type", "value": "application/json" };
        return _this;
    }
    Finder.prototype.findTestCaseByRunId = function (projectId, runId) {
        return this.driver.get("/api/v3/projects/" + projectId + "/test-runs/" + runId + "?expand=testcase.teststep")
            .then(function (response) {
            return TestCase_1.TestCase.fromJSON(response.data.test_case);
        });
    };
    Finder.prototype.findLastRun = function (projectId, runId) {
        return this.driver.get("/api/v3/projects/" + projectId + "/test-runs/" + runId + "/test-logs/last-run")
            .then(function (response) {
            var testLog = new AutomationTestLog_1.AutomationTestLog();
            return testLog.fromJSON(response.data);
        });
    };
    Finder.prototype.findTestRunsInModule = function (projectId, moduleId, moduleType) {
        var query = new Query_1.Query();
        query.objectType = "test-runs";
        query.query = "'" + moduleType + "' = '" + moduleId + "'";
        return this.search(projectId, query)
            .then(function (queryResults) {
            var testRuns = [];
            for (var _i = 0, queryResults_1 = queryResults; _i < queryResults_1.length; _i++) {
                var queryResult = queryResults_1[_i];
                for (var _a = 0, _b = queryResult.items; _a < _b.length; _a++) {
                    var item = _b[_a];
                    var testRun = TestRun_1.TestRun.fromJSON(item);
                    testRun.testCaseId = parseInt(testRun.getLink("test-case").match(/test-cases\/(\d+)/)[1]);
                    testRuns.push(testRun);
                }
            }
            return testRuns;
        });
    };
    Finder.prototype.search = function (projectId, query) {
        var _this = this;
        return this.runQuery(projectId, query)
            .then(function (queryResult) {
            var queries = [queryResult];
            for (var i = 2; i <= queryResult.pageCount(); i++) {
                query.page = i;
                queries.push(_this.runQuery(projectId, query));
            }
            return Promise.all(queries);
        });
    };
    Finder.prototype.runQuery = function (projectId, query) {
        var params = query.searchParams;
        return this.driver.post("/api/v3/projects/" + projectId + "/search" + params, query.toJSON())
            .then(function (response) {
            return new QueryResult_1.QueryResult(response.data);
        });
    };
    return Finder;
}(Requester_1.Requester));
exports.Finder = Finder;
